diff -r 3da9153bcf2d -r 0324c269b390 javafx-beans/src/com/sun/javafx/collections/ArrayListenerHelper.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/javafx-beans/src/com/sun/javafx/collections/ArrayListenerHelper.java	Mon Apr 22 15:45:02 2013 -0700
@@ -0,0 +1,332 @@
+/*
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package com.sun.javafx.collections;
+
+import com.sun.javafx.binding.ExpressionHelperBase;
+import java.util.Arrays;
+import javafx.beans.InvalidationListener;
+import javafx.collections.ArrayChangeListener;
+import javafx.collections.ObservableArray;
+
+/**
+ *
+ * @author akouznet
+ */
+public abstract class ArrayListenerHelper<T extends ObservableArray> extends ExpressionHelperBase {
+
+    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
+    // Static methods
+
+    public static <T extends ObservableArray> ArrayListenerHelper addListener(ArrayListenerHelper helper, T observable, InvalidationListener listener) {
+        if (listener == null) {
+            throw new NullPointerException();
+        }
+        return (helper == null)? new ArrayListenerHelper.SingleInvalidation(observable, listener) : helper.addListener(listener);
+    }
+
+    public static  ArrayListenerHelper removeListener(ArrayListenerHelper helper, InvalidationListener listener) {
+        if (listener == null) {
+            throw new NullPointerException();
+        }
+        return (helper == null)? null : helper.removeListener(listener);
+    }
+
+    public static <T extends ObservableArray> ArrayListenerHelper addListener(ArrayListenerHelper helper, T observable, ArrayChangeListener listener) {
+        if (listener == null) {
+            throw new NullPointerException();
+        }
+        return (helper == null)? new ArrayListenerHelper.SingleChange(observable, listener) : helper.addListener(listener);
+    }
+
+    public static  ArrayListenerHelper removeListener(ArrayListenerHelper helper, ArrayChangeListener listener) {
+        if (listener == null) {
+            throw new NullPointerException();
+        }
+        return (helper == null)? null : helper.removeListener(listener);
+    }
+
+    public static  void fireValueChangedEvent(ArrayListenerHelper helper, boolean sizeChanged, int from, int to) {
+        if (helper != null) {
+            helper.fireValueChangedEvent(sizeChanged, from, to);
+        }
+    }
+
+    public static  boolean hasListeners(ArrayListenerHelper helper) {
+        return helper != null;
+    }
+    
+    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
+    // Common implementations
+    
+    protected final T observable;
+
+    public ArrayListenerHelper(T observable) {
+        this.observable = observable;
+    }
+    
+    protected abstract ArrayListenerHelper addListener(InvalidationListener listener);
+    protected abstract ArrayListenerHelper removeListener(InvalidationListener listener);
+
+    protected abstract ArrayListenerHelper addListener(ArrayChangeListener<T> listener);
+    protected abstract ArrayListenerHelper removeListener(ArrayChangeListener<T> listener);
+
+    protected abstract void fireValueChangedEvent(boolean sizeChanged, int from, int to);
+    
+    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
+    // Implementations
+
+    private static class SingleInvalidation<T extends ObservableArray> extends ArrayListenerHelper<T> {
+
+        private final InvalidationListener listener;
+
+        private SingleInvalidation(T observable, InvalidationListener listener) {
+            super(observable);
+            this.listener = listener;
+        }
+
+        @Override
+        protected ArrayListenerHelper addListener(InvalidationListener listener) {
+            return new Generic(observable, this.listener, listener);
+        }
+
+        @Override
+        protected ArrayListenerHelper removeListener(InvalidationListener listener) {
+            return (listener.equals(this.listener))? null : this;
+        }
+
+        @Override
+        protected ArrayListenerHelper addListener(ArrayChangeListener listener) {
+            return new Generic(observable, this.listener, listener);
+        }
+
+        @Override
+        protected ArrayListenerHelper removeListener(ArrayChangeListener listener) {
+            return this;
+        }
+
+        @Override
+        protected void fireValueChangedEvent(boolean sizeChanged, int from, int to) {
+            listener.invalidated(observable);
+        }
+    }
+
+    private static class SingleChange<T extends ObservableArray> extends ArrayListenerHelper<T> {
+
+        private final ArrayChangeListener listener;
+
+        private SingleChange(T observable, ArrayChangeListener listener) {
+            super(observable);
+            this.listener = listener;
+        }
+
+        @Override
+        protected ArrayListenerHelper addListener(InvalidationListener listener) {
+            return new Generic(observable, listener, this.listener);
+        }
+
+        @Override
+        protected ArrayListenerHelper removeListener(InvalidationListener listener) {
+            return this;
+        }
+
+        @Override
+        protected ArrayListenerHelper addListener(ArrayChangeListener listener) {
+            return new Generic(observable, this.listener, listener);
+        }
+
+        @Override
+        protected ArrayListenerHelper removeListener(ArrayChangeListener listener) {
+            return (listener.equals(this.listener))? null : this;
+        }
+
+        @Override
+        protected void fireValueChangedEvent(boolean sizeChanged, int from, int to) {
+            listener.onChanged(observable, sizeChanged, from, to);
+        }
+    }
+
+    private static class Generic<T extends ObservableArray> extends ArrayListenerHelper<T> {
+
+        private InvalidationListener[] invalidationListeners;
+        private ArrayChangeListener[] changeListeners;
+        private int invalidationSize;
+        private int changeSize;
+        private boolean locked;
+
+        private Generic(T observable, InvalidationListener listener0, InvalidationListener listener1) {
+            super(observable);
+            this.invalidationListeners = new InvalidationListener[] {listener0, listener1};
+            this.invalidationSize = 2;
+        }
+
+        private Generic(T observable, ArrayChangeListener listener0, ArrayChangeListener listener1) {
+            super(observable);
+            this.changeListeners = new ArrayChangeListener[] {listener0, listener1};
+            this.changeSize = 2;
+        }
+
+        private Generic(T observable, InvalidationListener invalidationListener, ArrayChangeListener changeListener) {
+            super(observable);
+            this.invalidationListeners = new InvalidationListener[] {invalidationListener};
+            this.invalidationSize = 1;
+            this.changeListeners = new ArrayChangeListener[] {changeListener};
+            this.changeSize = 1;
+        }
+
+        @Override
+        protected Generic addListener(InvalidationListener listener) {
+            if (invalidationListeners == null) {
+                invalidationListeners = new InvalidationListener[] {listener};
+                invalidationSize = 1;
+            } else {
+                final int oldCapacity = invalidationListeners.length;
+                if (locked) {
+                    final int newCapacity = (invalidationSize < oldCapacity)? oldCapacity : (oldCapacity * 3)/2 + 1;
+                    invalidationListeners = Arrays.copyOf(invalidationListeners, newCapacity);
+                } else if (invalidationSize == oldCapacity) {
+                    invalidationSize = trim(invalidationSize, invalidationListeners);
+                    if (invalidationSize == oldCapacity) {
+                        final int newCapacity = (oldCapacity * 3)/2 + 1;
+                        invalidationListeners = Arrays.copyOf(invalidationListeners, newCapacity);
+                    }
+                }
+                invalidationListeners[invalidationSize++] = listener;
+            }
+            return this;
+        }
+
+        @Override
+        protected ArrayListenerHelper removeListener(InvalidationListener listener) {
+            if (invalidationListeners != null) {
+                for (int index = 0; index < invalidationSize; index++) {
+                    if (listener.equals(invalidationListeners[index])) {
+                        if (invalidationSize == 1) {
+                            if (changeSize == 1) {
+                                return new SingleChange(observable, changeListeners[0]);
+                            }
+                            invalidationListeners = null;
+                            invalidationSize = 0;
+                        } else if ((invalidationSize == 2) && (changeSize == 0)) {
+                            return new SingleInvalidation(observable, invalidationListeners[1-index]);
+                        } else {
+                            final int numMoved = invalidationSize - index - 1;
+                            final InvalidationListener[] oldListeners = invalidationListeners;
+                            if (locked) {
+                                invalidationListeners = new InvalidationListener[invalidationListeners.length];
+                                System.arraycopy(oldListeners, 0, invalidationListeners, 0, index+1);
+                            }
+                            if (numMoved > 0) {
+                                System.arraycopy(oldListeners, index+1, invalidationListeners, index, numMoved);
+                            }
+                            invalidationSize--;
+                            if (!locked) {
+                                invalidationListeners[invalidationSize] = null; // Let gc do its work
+                            }
+                        }
+                        break;
+                    }
+                }
+            }
+            return this;
+        }
+
+        @Override
+        protected ArrayListenerHelper addListener(ArrayChangeListener<T> listener) {
+            if (changeListeners == null) {
+                changeListeners = new ArrayChangeListener[] {listener};
+                changeSize = 1;
+            } else {
+                final int oldCapacity = changeListeners.length;
+                if (locked) {
+                    final int newCapacity = (changeSize < oldCapacity)? oldCapacity : (oldCapacity * 3)/2 + 1;
+                    changeListeners = Arrays.copyOf(changeListeners, newCapacity);
+                } else if (changeSize == oldCapacity) {
+                    changeSize = trim(changeSize, changeListeners);
+                    if (changeSize == oldCapacity) {
+                        final int newCapacity = (oldCapacity * 3)/2 + 1;
+                        changeListeners = Arrays.copyOf(changeListeners, newCapacity);
+                    }
+                }
+                changeListeners[changeSize++] = listener;
+            }
+            return this;
+        }
+
+        @Override
+        protected ArrayListenerHelper removeListener(ArrayChangeListener<T> listener) {
+            if (changeListeners != null) {
+                for (int index = 0; index < changeSize; index++) {
+                    if (listener.equals(changeListeners[index])) {
+                        if (changeSize == 1) {
+                            if (invalidationSize == 1) {
+                                return new SingleInvalidation(observable, invalidationListeners[0]);
+                            }
+                            changeListeners = null;
+                            changeSize = 0;
+                        } else if ((changeSize == 2) && (invalidationSize == 0)) {
+                            return new SingleChange(observable, changeListeners[1-index]);
+                        } else {
+                            final int numMoved = changeSize - index - 1;
+                            final ArrayChangeListener[] oldListeners = changeListeners;
+                            if (locked) {
+                                changeListeners = new ArrayChangeListener[changeListeners.length];
+                                System.arraycopy(oldListeners, 0, changeListeners, 0, index+1);
+                            }
+                            if (numMoved > 0) {
+                                System.arraycopy(oldListeners, index+1, changeListeners, index, numMoved);
+                            }
+                            changeSize--;
+                            if (!locked) {
+                                changeListeners[changeSize] = null; // Let gc do its work
+                            }
+                        }
+                        break;
+                    }
+                }
+            }
+            return this;
+        }
+
+        @Override
+        protected void fireValueChangedEvent(boolean sizeChanged, int from, int to) {
+            final InvalidationListener[] curInvalidationList = invalidationListeners;
+            final int curInvalidationSize = invalidationSize;
+            final ArrayChangeListener[] curChangeList = changeListeners;
+            final int curChangeSize = changeSize;
+
+            try {
+                locked = true;
+                for (int i = 0; i < curInvalidationSize; i++) {
+                    curInvalidationList[i].invalidated(observable);
+                }
+                for (int i = 0; i < curChangeSize; i++) {
+                    curChangeList[i].onChanged(observable, sizeChanged, from, to);
+                }
+            } finally {
+                locked = false;
+            }
+        }
+    }
+}
diff -r 3da9153bcf2d -r 0324c269b390 javafx-beans/src/com/sun/javafx/collections/ArraySyncer.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/javafx-beans/src/com/sun/javafx/collections/ArraySyncer.java	Mon Apr 22 15:45:02 2013 -0700
@@ -0,0 +1,137 @@
+/*
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package com.sun.javafx.collections;
+
+
+import javafx.beans.property.BooleanProperty;
+import javafx.beans.property.ReadOnlyBooleanProperty;
+import javafx.beans.property.ReadOnlyBooleanWrapper;
+import javafx.collections.ArrayChangeListener;
+import javafx.collections.ObservableArray;
+
+
+/**
+ *
+ * @author akouznet
+ */
+public class ArraySyncer<T extends ObservableArray> implements ArrayChangeListener<T> {
+    
+    protected final T array;
+    private ReadOnlyBooleanWrapper dirty = new ReadOnlyBooleanWrapper(this, "dirty", true);
+    private BooleanProperty parentDirty;
+    private boolean dirtyInFull;
+    private int dirtyRangeFrom;
+    private int dirtyRangeLength;
+
+    public ArraySyncer(T array, BooleanProperty parentDirty) {
+        this.array = array;
+        this.parentDirty = parentDirty;
+        array.addListener(this);
+    }
+    
+    public ArraySyncer(T array) {
+        this(array, null);
+    }
+
+    public T get() {
+        return array;
+    }
+    
+    public ReadOnlyBooleanProperty dirtyProperty() {
+        return dirty;
+    }
+
+    public final boolean isDirty() {
+        return dirty.get();
+    }
+
+    /**
+     * Array was replaced
+     * @return true if array was replaced; false otherwise
+     */
+    protected final boolean isDirtyInFull() {
+        return dirtyInFull;
+    }
+    
+    protected final int getDirtyRangeLength() {
+        return dirtyRangeLength;
+    }
+
+    protected final int getDirtyRangeFrom() {
+        return dirtyRangeFrom;
+    }
+    
+    private void markDirty() {
+        dirty.set(true);
+        if (parentDirty != null) {
+            parentDirty.set(true);
+        }
+    }
+
+    /**
+     * @param dirty if true, the whole collection is marked as dirty;
+     * if false, the whole collection is marked as not-dirty
+     */
+    public final void setDirty(boolean dirty) {
+        this.dirtyInFull = dirty;
+        if (dirty) {
+            markDirty();
+            dirtyRangeFrom = 0;
+            dirtyRangeLength = array.size();
+        } else {
+            this.dirty.set(false);
+            dirtyRangeFrom = dirtyRangeLength = 0;
+        }
+    }
+    
+    /**
+     * Adds a dirty range
+     * @param from index of the first modified element
+     * @param length length of the modified range
+     */
+    protected final void addDirtyRange(int from, int length) {
+        if (length > 0 && !dirtyInFull) {
+            markDirty();
+            if (dirtyRangeLength == 0) {
+                dirtyRangeFrom = from;
+                dirtyRangeLength = length;
+            } else {
+                int fromIndex = Math.min(dirtyRangeFrom, from);
+                int toIndex = Math.max(dirtyRangeFrom + dirtyRangeLength, from + length);            
+                dirtyRangeFrom = fromIndex;
+                dirtyRangeLength = toIndex - fromIndex;
+            }
+        }
+    }    
+        
+    @Override
+    public void onChanged(T observableArray, boolean sizeChanged, int from, int to) {
+        if (sizeChanged) {
+            setDirty(true);
+        } else {
+            addDirtyRange(from, to - from);
+        }
+    }
+}
diff -r 3da9153bcf2d -r 0324c269b390 javafx-beans/src/com/sun/javafx/collections/FloatArraySyncer.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/javafx-beans/src/com/sun/javafx/collections/FloatArraySyncer.java	Mon Apr 22 15:45:02 2013 -0700
@@ -0,0 +1,60 @@
+/*
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package com.sun.javafx.collections;
+
+
+import javafx.beans.property.BooleanProperty;
+import javafx.collections.ObservableFloatArray;
+
+
+/**
+ *
+ * @author akouznet
+ */
+public class FloatArraySyncer extends ArraySyncer<ObservableFloatArray> {
+
+    public FloatArraySyncer(ObservableFloatArray array, BooleanProperty parentDirty) {
+        super(array, parentDirty);
+    }
+    
+    /**
+     * This method is used to sync arrays on pulses. This method expects
+     * the same array was synced before. The usage is similar to toArray method
+     * so always use it as following: {@code dest = source.syncTo(dest);}
+     * @param array previously synced array
+     * @return a synced array, which is the same or new array (depending on 
+     * the change).
+     */
+    public float[] syncTo(float[] array) {
+        if (this.array == null) {
+            return null;
+        }
+        if (isDirtyInFull() || array == null || array.length != this.array.size()) {
+            return this.array.toArray(array);
+        }
+        this.array.copyTo(getDirtyRangeFrom(), array, getDirtyRangeFrom(), getDirtyRangeLength());
+        return array;
+    }     
+}
diff -r 3da9153bcf2d -r 0324c269b390 javafx-beans/src/com/sun/javafx/collections/IntegerArraySyncer.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/javafx-beans/src/com/sun/javafx/collections/IntegerArraySyncer.java	Mon Apr 22 15:45:02 2013 -0700
@@ -0,0 +1,60 @@
+/*
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package com.sun.javafx.collections;
+
+
+import javafx.beans.property.BooleanProperty;
+import javafx.collections.ObservableIntegerArray;
+
+
+/**
+ *
+ * @author akouznet
+ */
+public class IntegerArraySyncer extends ArraySyncer<ObservableIntegerArray> {
+
+    public IntegerArraySyncer(ObservableIntegerArray array, BooleanProperty parentDirty) {
+        super(array, parentDirty);
+    }
+    
+    /**
+     * This method is used to sync arrays on pulses. This method expects
+     * the same array was synced before. The usage is similar to toArray method
+     * so always use it as following: {@code dest = source.syncTo(dest);}
+     * @param array previously synced array
+     * @return a synced array, which is the same or new array (depending on 
+     * the change).
+     */
+    public int[] syncTo(int[] array) {
+        if (this.array == null) {
+            return null;
+        }
+        if (isDirtyInFull() || array == null || array.length != this.array.size()) {
+            return this.array.toArray(array);
+        }
+        this.array.copyTo(getDirtyRangeFrom(), array, getDirtyRangeFrom(), getDirtyRangeLength());
+        return array;
+    }     
+}
diff -r 3da9153bcf2d -r 0324c269b390 javafx-beans/src/javafx/collections/ArrayChangeListener.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/javafx-beans/src/javafx/collections/ArrayChangeListener.java	Mon Apr 22 15:45:02 2013 -0700
@@ -0,0 +1,40 @@
+/*
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package javafx.collections;
+
+/**
+ * Interface that receives notifications of changes to an ObservableArray.
+ */
+public interface ArrayChangeListener<T extends ObservableArray> {
+    
+    /**
+     * Called after a change has been made to an ObservableArray.
+     *
+     * @param sizeChanged indicates size of array changed
+     * @param from A beginning (inclusive) of an interval related to the change
+     * @param to An end (exclusive) of an interval related to the change.
+     */
+    public void onChanged(T observableArray, boolean sizeChanged, int from, int to);    
+}
